/*
 * 新月ネットワークから一覧データを取得します。。
 *
 * @param host
 * @param port
 * @param public_gateway_mode
 * @param func データ取得に成功した場合に呼び出す関数
 * @param errfunc 失敗した場合に呼び出す関数。
 */
function getCacheData(host, port, public_gateway_mode, func, errfunc) {
	getCsvData(host, port, "index", public_gateway_mode, func, errfunc);
}

/*
 * 新月ネットワークから新着データを取得します。。
 *
 * @param host
 * @param port
 * @param public_gateway_mode
 * @param func データ取得に成功した場合に呼び出す関数
 * @param errfunc 失敗した場合に呼び出す関数。
 */
function getRecentData(host, port, public_gateway_mode, func, errfunc) {
	getCsvData(host, port, "recent", public_gateway_mode, func, errfunc);
}

/*
 * 新月ネットワークからCSVデータを取得します。。
 *
 * @param host
 * @param port
 * @param method
 * @param public_gateway_mode
 * @param func データ取得に成功した場合に呼び出す関数
 * @param errfunc 失敗した場合に呼び出す関数。
 */
function getCsvData(host, port, method, public_gateway_mode, func, errfunc) {
	var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
	
	var reqstr = "http://" + combHP(host, port) + "/gateway.cgi/csv/" + method + "/file,stamp,date,path,uri,type,title,records,size,tag,sugtag";
	
	request.onreadystatechange = function() {receiveData(request, func, host, port, public_gateway_mode);}
	request.onerror = errfunc;
	request.open("GET", reqstr, true);
	request.send(null);
}

/*
 * リクエストのステータスが変化した場合呼び出されます。
 *
 * @param request
 * @param func データ取得に成功した場合に呼び出す関数
 * @param errfunc 失敗した場合に呼び出す関数。
 * @param public_gateway_mode 公開ゲートウェイモード
 */
function receiveData(request, func, host, port, public_gateway_mode) {
	if (request.readyState == 4) {
		if (request.status == 200) {
			var cookie = getCookie(host, "access");
			var thInfoMngr = new ThreadInfoManager(request.responseText, cookie, public_gateway_mode);
		    func(thInfoMngr);
		}
	}
}